﻿using System;

using DevExpress.Xpo;

namespace TestProject
{
    /// <summary>
    /// 테스트 객체
    /// </summary>
    public class TestObject : XPObject
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 주제
        /// </summary>
        private string subject;

        /// <summary>
        /// 송신 일시
        /// </summary>
        private DateTime sendTime;

        /// <summary>
        /// 첨부 여부
        /// </summary>
        private bool hasAttachment;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 주제 - Subject

        /// <summary>
        /// 주제
        /// </summary>
        public string Subject
        {
            get
            { 
                return this.subject;
            }
            set
            { 
                SetPropertyValue<string>("Subject", ref this.subject, value);
            }
        }

        #endregion
        #region 송신 일시 - SendTime

        /// <summary>
        /// 송신 일시
        /// </summary>
        public DateTime SendTime
        {
            get
            {
                return this.sendTime;
            }
            set
            {
                SetPropertyValue<DateTime>("SendTime", ref this.sendTime, value);
            }
        }

        #endregion
        #region 첨부 여부 - HasAttachment

        /// <summary>
        /// 첨부 여부
        /// </summary>
        public bool HasAttachment
        {
            get
            { 
                return this.hasAttachment;
            }
            set
            { 
                SetPropertyValue<bool>("HasAttachment", ref this.hasAttachment, value);
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - TestObject()

        /// <summary>
        /// 생성자
        /// </summary>
        public TestObject() : base(Session.DefaultSession)
        {
        }

        #endregion
        #region 생성자 - TestObject(session)

        /// <summary>
        /// 생성자
        /// </summary>
        /// <param name="session">세션</param>
        public TestObject(Session session) : base(session)
        {
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성 후 처리하기 - AfterConstruction()

        /// <summary>
        /// 생성 후 처리하기
        /// </summary>
        public override void AfterConstruction()
        {
            base.AfterConstruction();
        }

        #endregion
    }
}